/*****
*
* Copyright (C) 1998 - 2000 Vandoorselaere Yoann
* All Rights Reserved
*
* This file is part of the Prelude program.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*
*****/

#ifndef ALERT_PRV_H
#define ALERT_PRV_H

#include "list.h"


typedef struct {
        /*
         * This is only used inside Prelude to add
         * the alert structure to the async IO queue.
         */
        struct list_head list;
        
        /*
         * DetectPlugins infos.
         */
        char *name;
        size_t namelen;
        char *author;
        size_t authorlen;
        char *contact;
        size_t contactlen;
        char *desc;
        size_t desclen;
        char *quickmsg;
        size_t quickmsglen;
        
        rkind_t kind;
        unsigned int count;
        
        /*
         * Report Infos.
         */
        char message[1024];
        size_t messagelen;
        
        time_t time_start, time_end;
        
        /*
         * Received packet.
         */
        int depth;
        Packet_t *packet;     /* Read packet.h for infos about this structure */
} alert_t;



#define alert_quickmsg(report) (report)->quickmsg
#define alert_quickmsg_len(report) (report)->quickmsglen

#define alert_from(report) (report)->name
#define alert_from_len(report) (report)->namelen

#define alert_author(report) (report)->author
#define alert_author_len(report) (report)->authorlen

#define alert_contact(report) (report)->contact
#define alert_contact_len(report) (report)->contactlen

#define alert_desc(report) (report)->desc
#define alert_desc_len(report) (report)->desclen

#define alert_message(report) (report)->message
#define alert_message_len(report) (report)->messagelen

#define alert_kind(report) (report)->kind
#define alert_count(report) (report)->count
#define alert_time_start(report) (report)->time_start
#define alert_time_end(report) (report)->time_end
#define alert_depth(report) (report)->depth
#define alert_packet(report) (report)->packet


#endif



