%define name prelude
%define majver 0
%define version 0.3
%define release 1mdk

Summary: A Network Intrusion Detection System
Name: %{name}
Version: %{version}
Release: %{release}
Source0: %{name}-%{version}.tar.bz2
Source1: prelude.init
Copyright: GPL
Group: Networking/Other
BuildRoot: /var/tmp/prelude
Provides: prelude = %{version}-%{release}
Requires: libprelude = %{version}-%{release}

%package -n libprelude%{majver}
Summary: Shared code between Prelude, Prelude Report, and plugins.
Group: System/Libraries
Provides: libprelude = %{version}-%{release}

%package -n prelude-doc
Summary: Prelude API documentation.
Group: Books/Other
Provides: prelude-doc = %{version}-%{release}

%package -n prelude-report
Summary: The Prelude Report server
Group: System/Servers
Provides: prelude-report = %{version}-%{release}
Requires: libprelude = %{version}-%{release}, openssl


%description
Prelude is a general-purpose network intrusion detection system, written
entirely from scratch, in C. Right now, it handles all of the TCP/IP stack over
Ethernet.

Prelude is divided in three parts:
the core of the program, Prelude, which scans the network interface, retrieves
packets and slices them, a series of intrusion detection plugins, each
dedicated to a particular kind of attack, Prelude Report, a server which
Prelude
contacts in order to report an intrusion.

The interesting part is plugins: you can write your own, dedicated to a special
intrusion detection that you know of and share it with others. For example,
bundled with the source is a plugin to detect scanning attacks. There is more,
and you can write more. Moreover, plugins are only called when necessary.


%description -n libprelude%{majver}
This library contain shared code between Prelude, Prelude Report,
and their respective plugins. 

%description -n prelude-report
Prelude Report have a number of plugins that know how to translate
a Prelude alert into an user readable alert.
The main task of the Prelude Report server is to get alert from
Prelude sensor (which are it's client) and create an user readable 
alert with all alert gathered.

%description -n prelude-doc
Prelude API documentation.


%prep
%setup 

%build
%configure
%make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
%makeinstall

echo "PRELUDE_INTERFACES=eth0" > $RPM_BUILD_ROOT/%{_sysconfdir}/prelude-init.conf

mkdir -p $RPM_BUILD_ROOT%{_initrddir}
install -m 755 $RPM_SOURCE_DIR/prelude.init \
	$RPM_BUILD_ROOT%{_initrddir}/prelude

%clean
rm -rf $RPM_BUILD_ROOT

%post -n libprelude%{majver} -p /sbin/ldconfig
%postun -n libprelude%{majver} -p /sbin/ldconfig

%files -n libprelude%{majver}
%defattr(-,root,root)
%{_libdir}/libprelude.so.*

%files -n prelude
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog NEWS README TODO CREDITS
%{_bindir}/prelude
%{_libdir}/prelude/detects/*
%{_localstatedir}/prelude
%config %{_sysconfdir}/prelude/prelude.conf
%config(noreplace) %{_initrddir}/prelude
%config(noreplace) %{_sysconfdir}/prelude-init.conf



%files -n prelude-report
%defattr(-,root,root)
%{_bindir}/prelude_report
%{_libdir}/prelude/reports/*
%{_localstatedir}/prelude
%config %{_sysconfdir}/prelude/prelude-report.conf
%config(noreplace) %{_initrddir}/prelude



%files -n prelude-doc
%defattr(-,root,root)
%{_docdir}/prelude


%changelog
* Thu Mar 29 2001 Yoann Vandoorselaere <yoann@mandrakesoft.com> 0.3-1mdk
- first packaging attempt.
