/* HTAB = 4 */
/****************************************************************************
 * recycler.h -- Declarations de la bibliotheque recycler.					*
 *--------------------------------------------------------------------------*
 * (c) 2000 Bertrand Petit, tous droits reserves.							*
 ****************************************************************************/

#ifndef LIBRECYCLER_H
#define LIBRECYCLER_H

/****************************************************************************
 * Definitions de types.													*
 ****************************************************************************/
/* Handle d'un recycleur. */
typedef struct _recycler recycler_t;

/* Valeurs de verite. Il est ogligatoire que la va leur de la macro
 * FALSE soit l'entier zero. La valeur de TRUE importe peut du comment
 * qu'elle est entiere et differente de zero.
 */
#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE 1
#endif

/****************************************************************************
 * Prototypes.																*
 ****************************************************************************/
extern recycler_t *RecyclerCreate(size_t ChunkSize,
				  unsigned int ChunksMax);
extern int RecyclerDestroy(recycler_t * Recycler, int Force);
extern int RecyclerGrow(recycler_t * Recycler, unsigned int ChunksCount);
extern int RecyclerShrink(recycler_t * Recycler, unsigned int ChunksCount);
extern void *RecyclerGetChunk(recycler_t *Recycler);

extern void RecyclerLockChunk(const void *Data);
extern void RecyclerReleaseChunk(const void *Data);
extern int RecyclerIsLocked(const void *data);

#define RecyclerGetChunksMax(recycler) recycler->max
#define RecyclerGetChunksCount(recycler) recycler->count
#define RecyclerHasFreeChunks(recycler) (Recycler->freelist != NULL)


#endif

/****************************************************************************
 * Fin du fichier recycler.h						    *
 ****************************************************************************/
